@br-setup

;;;;;;yinitbasic for interactive purposes:
;yinit = [round(ymax[sortorder]),round(ymin[sortorder])]
;yinit = yinit[uniq(yinit,sort(yinit))]

yinit = yinall

nsetup2 = n_elements(yinit)

print,'reading in blue flat field...'
flat = mrdfits('avflatlamp-blue.fits',0,head)

saw = abs(shift(flat,1)-shift(flat,-1))

tmpimg = rotate(saw,3)

window, 1,xsize=1000,ysize=1000
astrim,alog10(tmpimg)>0.5<3.

firstguess = 350. + 9.85*yinit ; for the bottom half
top = where(yinit gt 170.)
bot = where(yinit le 170.)
firstguess[top] = 270. + 9.85*yinit[top] ; for the top half
;horz,firstguess,min=3100,max=3200,color='yellow'


slope_bot = 10.2664
slope_top = 10.2300
y0_bot = 366.463
y0_top = 269.625
;secondguess! ==> yfit
part1 = where(yinit le 169.)
part2 = where(yinit gt 169.)
yfit = yinit*0.
yfit[part1] = y0_bot + slope_bot*yinit[part1]
yfit[part2] = y0_top + slope_top*yinit[part2]
secondguess = yfit

;thirdguess --> (used to correct offset in traces after fitting)
slope_bot2 = 10.2927
slope_top2 = 10.2882
y0_bot2 = 349.406
y0_top2 = 242.864
ythirdguess = yfit*0.
ythirdguess[part1] = y0_bot2 + slope_bot2*yinit[part1]
ythirdguess[part2] = y0_top2 + slope_top2*yinit[part2]



djs_oplot,yfit[part1]*0.+3025.,secondguess[bot],psym=1,color='blue'
djs_oplot,yfit[part2]*0.+2950.,secondguess[top],psym=1,color='navy'


answer = ''
print,"--------%---------%---------%---------%"
read,answer,prompt="STEP4-identify-slits.pro: ARE THE INITIAL GUESSES TO THE SLIT POSITIONS ACCURATE? [Y/N]:"

IF strupcase(answer) ne 'Y' then begin & $
xcurse = fltarr(nsetup2)   & $
ycurse = fltarr(nsetup2)  & $
  & $
print, 'please identify all ', nsetup2, ' slits with the cursor (in order).'  & $
for i=0,n_elements(bot)-1 do begin & $  & $
   djs_oplot,[3075.],[secondguess[i]], psym=1,color='magenta' & $  & $
   cursor,xtmp,ytmp,/up & $  & $
   xcurse[i] = xtmp & $  & $
   ycurse[i] = ytmp & $  & $
   print, 'finished identifying slit number ', i & $  & $
   djs_oplot,[xtmp],[ytmp],psym=1,color='red' & $  & $
   djs_oplot,[xtmp,3075.],[ytmp,secondguess[i]],color='pink' & $  & $
   endfor  & $
  & $
for i=nsetup2-1,nsetup2-n_elements(bot), -1 do begin & $  & $
   djs_oplot,[3075.],[secondguess[i]], psym=1,color='magenta' & $  & $
   cursor,xtmp,ytmp,/up & $  & $
   xcurse[i] = xtmp & $  & $
   ycurse[i] = ytmp & $  & $
   print, 'finished identifying slit number ', i & $  & $
   djs_oplot,[xtmp],[ytmp],psym=1,color='red' & $  & $
   djs_oplot,[xtmp,3075.],[ytmp,secondguess[i]],color='pink' & $  & $
   endfor  & $
yfitted = ycurse  & $
endif else begin  & $
   yfitted = secondguess  & $
endelse


window, 2,xsize=600,ysize=600
djs_plot, yinit, yfitted, psym=1, color='red', xran=[0,350],yran=[0,4096]
;djs_oplot, yinit, firstguess, color='yellow'

t1 = where(yinit le 165 and yfitted gt 0)
par1 = linfit(yinit[t1],yfitted[t1])
t2 = where(yinit gt 195 and yinit le 315 and yfitted gt 0)
par2 = linfit(yinit[t2],yfitted[t2])

yarr = findgen(350)
yfitp1 = par1[0] + par1[1]*yarr
yfitp2 = par2[0] + par2[1]*yarr


djs_plot, yinit, yfitted, psym=1, color='red', xran=[0,350],yran=[0,4096]
djs_oplot,yarr,yfitp1,color='yellow'
djs_oplot,yarr,yfitp2,color='blue'

ver, [165.,171.]
horz, 2048.
badslits = where(yinit gt 165. and yfit le 2048.) ;these slits sit in the overlap region
print, "THERE ARE",n_elements(badslits)," BAD SLITS CUT OFF BY OVERLAP REGION. THEY ARE: ", strtrim(string(fix(badslits)),1)

temp1 = where(yarr eq 165)
horz, yfitp1[temp1],color='yellow'
temp2 = where(yarr eq 171)
horz, yfitp2[temp2], color='blue'

yfit = yinit*0.
part1 = where(yinit le 165.)
part2 = where(yinit gt 165.)
yfit[part1] = par1[0]+par1[1]*yinit[part1]
yfit[part2] = par2[0]+par2[1]*yinit[part2]

save,yfit,ythirdguess,badslits,filename='b-s3-'+obj+'.sav'

