;visualize = 0
visualize = 1

step3file = (findfile('b-s3*.sav'))[0]
restore,step3file
;saved information=yfit,badslits
obj = strmid(step3file,5,stregex(step3file,'.sav')-5)

print,'reading in blue flat field...'
flat = mrdfits('avflatlamp-blue.fits',0,head)
saw = abs(shift(flat,1)-shift(flat,-1))
rn = 5.
var = (flat + (flat eq 0) + rn^2.)
ivar = 1./( shift(var,1) + shift(var,-1) )


;sigsaw = sqrt( (shift(var,1) + shift(var,-1)) > 0)
;gdpt = where(abs(saw) GT 8.*sigsaw AND sigsaw NE 0., ngd)
;mask = saw*0.
;mask[gdpt] = 1.

;;;;; in the case of using ystart in trace_crude (when xstart is not used)
;;thresh = 0.5*median(abs(saw[gdpt]))
;;ystart = 3000

; in the case of using xstart in trace_crude (what step4 was for -
; cannot use ystart in this case)
xstart= 4096.-yfit
nslit = n_elements(xstart)

xset = trace_crude(saw,ivar,xstart=xstart,yset=yset)
; xset = the positions of the slits
; yset = an array of the opposite position on the slit - there for
;                                                        convenience
;                                                        considering,
;                                                        just ranges [0,4096]


;now remove unusual zero'ed traces... where xset[*,slit] = xstart[slit]


xres = xset*0.
expr = 'p[0]+p[1]*X + p[2]*X^2.'
slitpar    = fltarr(nslit,3)
slitparerr = fltarr(nslit,3)


; the derivative of xset
xsetddx = xset*0.
for i=0, nslit - 1 do xsetddx[*,i] = shift(xset[*,i],1) - xset[*,i]
; the second derivative of xset
xsetddx2 = xset*0.
for i=0, nslit - 1 do xsetddx2[*,i] = shift(xsetddx[*,i],1) - xsetddx[*,i]

for i=0, nslit - 1 do begin & $
 ;take all good pixels and fit them to a spline function
 ;good pixels are those where xset ne 0 and d/dx(xset) ne 0
   gd = where(xset[*,i]-xstart[i] ne 0 and xsetddx[*,i] ne 0 and xsetddx2[*,i] ne 0,ngd) & $
   if ngd gt 0 then begin & $
   par = mpfitexpr(expr,yset[gd,i],xset[gd,i],perror=dpar) & $
   xres[*,i] = par[0]+par[1]*yset[*,i]+par[2]*(yset[*,i]^2.) & $
;;   djs_plot,xset[*,i]-xstart[i],yran=[-50,50],psym=3,color='blue' & $
;;   djs_oplot,xres[*,i]-xstart[i],psym=3,color='red' & $
   slitpar[i,*] = par & $
   slitparerr[i,*] = dpar & $
   endif else begin & $
   print,'slit number ',i,' has no good trace from trace_crude' & $
   endelse & $
endfor
   
;------------------------------
;now refine the fits further....
;------------------------------
exprlin = 'p[0]+p[1]*X'

;------------------------------
;0th order: was xstart accurate? --> recalculate "xstart" as "xslits"
;------------------------------
gd = where(slitpar[*,0] gt 0 and slitpar[*,0] le 4096)
fit0 = mpfitexpr(exprlin,xstart[gd],slitpar[gd,0],perror=dfit0)
if visualize eq 1 then begin & $
window,2,xsize=800,ysize=800 & $
djs_plot,xstart,slitpar[*,0],psym=1,color='pink',xran=[0,4096],yran=[0,4096], xtitle="XSTART", ytitle="X_SLITFIT"  & $
djs_oplot,[0,5000],[0,5000],color='blue' & $
djs_oplot,xstart[gd],slitpar[gd,0],psym=1,color='red' & $
djs_oplot,xstart,fit0[0]+fit0[1]*xstart,color='yellow' & $
print, 'gd', n_elements(gd) & $
print, 'fit0', fit0 & $
cursor,x,y,/up & $
endif
xslits = fit0[0] + fit0[1]*xstart
help,xslits

;------------------------------
;1st order: how does the linear term of the parabolic fit?
; this controls where the dip in the parabolic fit sits as a function of y
;------------------------------
gd = where(slitpar[*,1] ne 0 and abs(slitpar[*,1]) le 0.020)
fit1 = mpfitexpr(exprlin,xstart[gd],slitpar[gd,1],perror=dfit1)
xfitpar1 = fit1[0] + fit1[1]*xstart
if visualize eq 1 then begin & $
djs_plot,xstart,slitpar[*,1],psym=1,color='pink',xran=[0,4096],yran=[-1,1]*0.020, xtitle="XSTART", ytitle="YDIP" & $
djs_oplot,xstart[gd],slitpar[gd,1],psym=1,color='red' & $
djs_oplot,xstart,xfitpar1,color='yellow' & $
print, 'gd', n_elements(gd) & $
print, 'fit1', fit1 & $
cursor,x,y,/up & $
   endif 
;;;;----> This slope is very sensitive to outliers.  In order to correct,
;;;;we cut out outliers from "fit1" fit.  First guess to slope:
;slope = (slitpar[0,1]-slitpar[99,1])/(xstart[0]-xstart[1])
;;;;fit it through the data midpoint xstart = 2048, y=mean(slitpar[*,1])
;xfit1g = mean(slitpar[*,1]) + slope*(xstart-2048.)

;------------------------------
;2st order: how does the parabola vary as a function of x?
;------------------------------
gd = where(slitpar[*,2] ne 0 and abs(slitpar[*,2]) le 1.e-5)
fit2 = mpfitexpr(exprlin,xstart[gd],slitpar[gd,2],perror=dfit1)
xfitpar2 = fit2[0] + fit2[1]*xstart
print,fit2
if visualize eq 1 then begin & $
djs_plot,xstart,slitpar[*,2],psym=1,color='pink',xran=[0,4096],yran=[-1,1]*1.e-5, xtitle="XSTART", ytitle="QUADRATIC TERM" & $
djs_oplot,xstart[gd],slitpar[gd,1],psym=1,color='red' & $
djs_oplot,xstart,xfitpar2,color='yellow' & $
print, 'gd', n_elements(gd) & $
print, 'fit2', fit2 & $
cursor,x,y,/up & $
   endif



; Xvalues not exactly right... ?? need to befit/reset
xstart2 = 4096-ythirdguess
fitzerothorder = linfit(xslits,xstart2)

djs_plot,xslits,xstart2,psym=1,color='red'
djs_oplot,[0,5000],[0,5000],color='blue'
cursor,x,y



;-%-%-%-%-%-%-%-%-%-%-%-%
; WHAT WOULD BE THE TRACE FUNCTION AT ANY POSITION ON THE MASK??
;-%-%-%-%-%-%-%-%-%-%-%-%
xarr = findgen(4096)
yarr = findgen(4096)
anytrace=fltarr(4096,4096)
for slit=0, 4096-1 do begin anytrace[*,slit] = (fitzerothorder[0] + fitzerothorder[1]*(fit0[0]+fit0[1]*xarr[slit])) + (fit1[0]+fit1[1]*xarr[slit])*yarr + (fit2[0]+fit2[1]*xarr[slit])*yarr^2.


;------------%-----------&------------%-----------&------------%
; NOW MAKE SURE THE ADJUSTED FITS MAKE SENSE:
;------------%-----------&------------%-----------&------------%

slitfit = slitpar*0.
slitfit[*,0] = xslits;xstart2
slitfit[*,1] = xfitpar1
slitfit[*,2] = xfitpar2

xpar = xres

if visualize eq 1 then begin & $
;plot the residuals... & $
xarr = findgen(4096) & $
rms = [-10000.] & $
djs_plot, [0,4096],[-10,10],/nodata & $
for i=0, nslit-1, 1 do begin & $
   gd = where(xset[*,i]-xstart[i] ne 0 and xsetddx[*,i] ne 0 and xsetddx2[*,i] ne 0,ngd) & $
   xres[*,i] = slitfit[i,0]+slitfit[i,1]*xarr + slitfit[i,2]*xarr^2. & $
   if ngd gt 0 then begin & $
   djs_oplot, xset[gd,i]-xres[gd,i],psym=1,color='blue' & $
   rms = [rms,xset[gd,i]-xres[gd,i]] & $
;   cursor,x,y & $
   endif & $
   endfor & $
rms = rms[1:*] & $
print, 'MEAN RMS OF TRACE FIT = ',mean(RMS),' pixels' & $
endif
;--------------------------
; PLOT SLITS ON SAW/FLAT IMAGE COMBO
;--------------------------

plotimage = saw>0
plotimage[*,0:1000] = flat[*,0:1000]/2.
plotimage[*,2000:3000] = flat[*,2000:3000]/2.


SLITNUMBER = 's'+strtrim(string(fix(findgen(nslit))),1)

if visualize eq 1 then begin & $
astrim,alog10(plotimage>0)>1 & $
djs_oplot,xres,yset,psym=3,color='red' & $
xyouts,xres[1000,*],yset[1000,*],slitnumber,color=djs_icolor('red'),orientation=270 & $
endif

save,xres,yset,slitnumber,slitfit,fit0,fit1,fit2,anytrace,nslit,filename='b-s4-'+obj+'.sav'

