;visualize= 0
visualize= 1

; solve the wavelength solution from the arc file

step3file = (findfile('b-s3-*.sav'))[0]
restore,step3file
obj = strmid(step3file,0,stregex(step3file,'.sav'))
step4file=(findfile('b-s4-*.sav'))[0]
restore,step4file
xslits = slitfit[*,0]

arcblue = (findfile('simp.*arc-blue*.fits'))[0]
arcimg = mrdfits(arcblue,0,headarc)
arcimg = arcimg

;------------------
;ROTATE EVERYTHING:
;------------------
rarcimg = rotate(arcimg,3)
ry = 4096. - xres
rx = yset
yslits = 4096.-xslits
ryt = reverse(4096. - anytrace,2)
;calculate the peak values (min and max) of a trace beginning at pixel y (where x=0)
extremetracevals = fltarr(4096,2)
for i=0, 4096-1 do begin & $
   tmp = minmax(ryt[*,i]) & $
   extremetracevals[i,*] = tmp & $
   endfor


;------------------
;plot initial setup with arc image:
;------------------
;omit bad slits:
gdslits = takeaway(findgen(nslit),badslits)

if visualize eq 1 then begin & $
window,0,xsize=1000,ysize=1000 & $
astrim,alog10(rarcimg) & $
djs_oplot,rx[*,gdslits],ry[*,gdslits],psym=3,color='red' & $
xyouts,rx[1000,gdslits],ry[1000,gdslits],slitnumber[gdslits],color=djs_icolor('red') & $
   endif

;-------------
;SPACES BETWEEN SLIT EDGES = SLITS 
;------------- 
;plot each slit

@br-setup
if visualize eq 1 then wdelete, 2
nslits = nsetup
; GUESS AT PIXEL SHIFT AMOUNT FOR WAVELENGTH TO ALIGN:
XSHIFT = xpos[sortorder]*10.1904

goodslits = takeaway(findgen(nslit),badslits) ;take away 'missing' slits
goodslits = takeaway(goodslits,boxslits*2.) ;remove box slits
goodslits = setintersection(goodslits,realslit) ;make sure slits are real

slitwidth = fltarr(nslits)
objpositionblue = fltarr(nslits)
; SAMPLE THE ARC FOR ALL PIXELS >10px from each EDGE, i.e. EDGEDIST = 10
edgedist = 20

xarr = findgen(4096)
slitarc = fltarr(4096,nslits)
slitarcerr = fltarr(4096,nslits)
feature = fltarr(nslits) ;vs pos

;-----------------------------
;refine yslits positions....
;-----------------------------

refinedslitsfile = (findfile('b-slits-*.sav'))[0]
if refinedslitsfile eq '' then begin & $
   yslits_ref = yslits & $
   yslitstag = 1 & $
   endif else begin & $
   restore,refinedslitsfile & $
   yslitstag = 0 & $
   endelse 

badflag = fltarr(nslit)
for slit=0, nslit-1, 1 do begin & $
   tmp = where(goodslits eq slit, ngd) & $
   tmp2 = where(badslits eq slit+1, nbad) & $
   if ngd gt 0 and nbad lt 1 then begin & $
   loadct,5 & $
   yrange = minmax(ry[*,(slit-1):(slit)])+edgedist*[-1,1] & $
   tmp = where(yrange ge 4096 or yrange le 0,nbad2) & $
   if nbad2 lt 1 then begin & $
   if visualize eq 1 then begin & $

;;; now plot result & $

   window,1,xsize=1600.,ysize=200.,xpos=0,ypos=1000 & $
   tvimage,fltscl(rarcimg[*,(yrange[0]):(yrange[1])],/tv),pos=[0,0,1,1] & $
   djs_plot, xarr,ryt[*,fix(yslits[slit-1])]-yrange[0], color='red', $ & $
   /noerase,pos=[0,0,1,1],yran=yrange-yrange[0] & $
   djs_oplot, xarr,ryt[*,fix(yslits[slit])]-yrange[0], color='red' & $
   if yslitstag eq 1 then begin & $
   cursor,xtmp,ytmp,/up & $
   djs_oplot,[xtmp],[ytmp],psym=2,color='magenta' & $
   mintmp = min(abs(ryt[xtmp,*]-(ytmp+yrange[0])),imin) & $
   djs_oplot,xarr,ryt[*,imin]-yrange[0],color='green',thick=3,line=2 & $
   yslits_ref[slit-1] = imin & $ ;*0.997781+17.6220 & $
   djs_oplot,xarr,ryt[*,fix(yslits_ref[slit-1])]-yrange[0],color='green',thick=5,line=2 & $
   cursor,xtmp,ytmp,/up & $
   mintmp = min(abs(ryt[xtmp,*]-(ytmp+yrange[0])),imin2) & $
   djs_oplot,xarr,ryt[*,imin2]-yrange[0],color='dark green',thick=3,line=2 & $
   yslits_ref[slit] = imin2 & $ ;*0.997781+17.6220 & $
   djs_oplot,xarr,ryt[*,fix(yslits_ref[slit])]-yrange[0],color='dark green',thick=5,line=2 & $
   legend,['SLIT'+string(fix((slit-1)/2.))] & $
   wait, 0.1 & $
   wdelete,1 & $
   endif else begin & $
   djs_oplot,xarr,ryt[*,fix(yslits_ref[slit])]-yrange[0],color='dark green',thick=3,line=2 & $
   djs_oplot,xarr,ryt[*,fix(yslits_ref[slit-1])]-yrange[0],color='green',thick=3,line=2 & $
   legend,['SLIT'+string(fix((slit-1)/2.))] & $
   wait, 0.1 & $
   endelse & $
   endif & $
;;; now compute arc image & $
   arcposbounds = [fix(yslits_ref[slit-1]+edgedist),fix(yslits_ref[slit]-edgedist)] & $
   arcposbounds = arcposbounds[sort(arcposbounds)] & $
   if arcposbounds[0]-arcposbounds[1] ne 0 then begin & $
   arcposex = findgen((arcposbounds[1]-arcposbounds[0]))+arcposbounds[0] & $
   slitwidth[fix((slit-1)/2.)] = yslits_ref[slit] - yslits_ref[slit-1] & $
   objpositionblue[fix((slit-1)/2.)] = yslits_ref[slit-1] + slitwidth[fix((slit-1)/2.)]*objpercent[sortorder[fix((slit-1)/2.)]] & $
   for xpt=0, 4096-1 do begin & $
   arctmp = mean(reform(rarcimg[xpt,ryt[xpt,arcposex]])) & $
   arctmp2 = stddev(reform(rarcimg[xpt,ryt[xpt,arcposex]])) & $
   slitarc[xpt,fix((slit-1)/2.)] = arctmp & $
   slitarcerr[xpt,fix((slit-1)/2.)] = arctmp2 & $
   endfor & $
   if yslitstag eq 0 then begin & $
   window, 2 & $
   djs_plot,slitarc[*,fix((slit-1)/2.)] & $
   endif & $
   endif else begin & $
   badflag[slit] = 1 & $
   endelse & $
   endif else begin & $
   badflag[slit] = 2 & $
   endelse & $
   endif & $
   endfor

badslits2 = where(badflag eq 1,nbad2)
if nbad2 gt 0 then goodslits = takeaway(goodslits,badslits2)

yttmp = objpercent*0.
for i=0, nslits - 1 do yttmp[i] = yslits_ref[2*i]
objpositionblue = yttmp + slitwidth*objpercent[sortorder]
print,"FINISHED SORTING THROUGH ALL SOURCES."

yslits_rough = yslits
save,yslits_rough,yslits_ref,filename='b-slits-'+obj+'.sav'
djs_plot,yslits_rough,yslits_ref,psym=1,color='blue'
yslits= yslits_ref

print,"SAVING RESULTS TO:", "  b-s5-"+obj+'.sav'
save, slitarc,slitarcerr,xarr,yslits,nslits,boxslits,badslits,realslit,goodslits,gdslits,slitwidth,objpercent, xshift,rx,ry,ryt,objpositionblue,filename='b-s5-'+obj+'.sav'
