
;visualize=0
visualize=1

step3file = (findfile('b-s3*.sav'))[0]
obj = strmid(step3file,5,stregex(step3file,'.sav')-5)
restore,'b-s4-'+obj+'.sav'
restore,'b-s5-'+obj+'.sav'


if visualize eq 1 then begin & $
; ------*--------*------*--------*------*--------*------*--------*------*--------*
; Now plot all of the arc spectra in a line to see if they indeed,
; agree (based solely on the pixel shift inferred from slit positions)
window, 0, xsize=1024., ysize=nslits*25.  & $
xrange = [-2000,4096]  & $
djs_plot, [0,4096],[0,nslits+1.],/nodata,xran=[-2000,4096],xstyle=5  & $
   for i=0, nslits - 1 do djs_oplot,xarr-xshift[i],slitarc[*,i]/max(slitarc[*,i])+i, color='red'  & $
;                    rough wavelength solution for this grating and central wavelength:  & $
;lambda = 2509.37 + 1.08290*xpix (for slit 24) =
axis,xaxis=0,xrange = xrange, xtitle='X pixel - Xshift[i]'  & $
   axis,xaxis=1,xrange = 2509.37+1.08290*(xrange+451.445),xtitle=textoidl("wavelength (\AA)")  & $
; ------*--------*------*--------*------*--------*------*--------*------*--------*  & $
   endif


restore,'~/data/observing/general/lris/arc-calibs/lris-blue-arcspectrum.sav'
arcwave = arcwave
arcflux = arcflux/max(arcflux)
read_cat,'~/data/observing/general/lris/arc-calibs/lris-blue-linelist.dat',arclines;partialdata --- too many blue lines here...
linesarc = identifyfeatures(arcflux)
arclines = arcwave[linesarc]

;check to make sure there aren't any more badslits:
badflag = fltarr(nslits)
for i=0, nslits - 1 do begin & $
   tmp = where(slitarc[*,i] ne 0 and finite(slitarc[*,i]),ct) & $
   if ct le 0 then badflag[i] = 1 & $
   endfor
badslits2 = where(badflag eq 1)

skipslits = setunion([boxslits,fix(badslits/2.)],badslits2)



slitwavefolder = './wavelengthsolution-blue/'
spawn,'mkdir '+slitwavefolder
wavesolfile = (findfile('blue-wavesol.sav'))[0]
if wavesolfile eq '' then begin & $
roughwavesol = slitarc*0. & $
finewavesol = slitarc*0. & $
roughtofinesolution = fltarr(2,nslits) & $

for i=0, nslits - 1 do begin & $
   tmp = where(skipslits eq i,badct) & $
   if badct gt 0 then begin & $
   print, 'NOT FITTING BAD SLITS WAVELENGTH SOLUTION, SLIT #', i & $
   endif else begin & $
   roughwavesol[*,i] = 451.445 + 2509.37 + 1.08290*(xarr-xshift[i])   & $
   waveran = minmax(roughwavesol[*,i])   & $

;;;;; first identify all the prominent features in each arc spectrum.   & $
   linepx = identifyfeatures(slitarc[*,i])   & $
   slitwaves = roughwavesol[linepx,i] & $
   arcwaves = arclines[where(arclines ge waveran[0] and arclines le waveran[1])] & $

;;;;; match lines to one another to refine the wavelength solution & $

   window,2,xsize=1500,ysize=350,xpos=0,ypos=1000 & $
   djs_plot,arcwave,arcflux,color='blue',yran=[0,1.5] & $
   djs_oplot,roughwavesol[*,i],slitarc[*,i]/max(slitarc[*,i]),color='yellow' & $
   ver, arcwaves,color='blue',min=1.1,max=1.25 & $
   ver, slitwaves,color='yellow',min=1.3,max=1.5 & $
   legend,['SLIT '+strtrim(string(fix(i)),1)+'/'+strtrim(string(fix(nslits)),1)],/right,box=0,charsize=1.5 & $
   
   savefile = (findfile(slitwavefolder+'wavesol-slit'+strtrim(string(fix(i)),1)+'.sav'))[0] & $
   if savefile eq '' then begin & $
   ypt = 999. & $
   print, 'CLICK on an ARC line (blue) and then on the cooresponding line in our spectrum (yellow).' & $
   print, '      (to finish, click at any y point where y<0.)' & $
   pts = [0] & $
   pta = [0] & $
   while ypt ge 0 do begin & $
   cursor,x,y,/up & $
   tmparc = min(abs(arcwaves-x),iminarc) & $
   aw = arcwaves[iminarc] & $
   ver, aw, line=1, color='light blue' & $
   cursor,x,y,/up & $
   tmpslit = min(abs(slitwaves-x),iminslit) & $
   sw = slitwaves[iminslit] & $
   ver, sw, line=1, color='yellow' & $
   pts = [pts, sw] & $
   pta = [pta, aw] & $
   cursor,xpt,ypt,/up & $
   endwhile & $
   pts = pts[1:*] & $
   pta = pta[1:*] & $

   res = linfit(pts,pta) & $
   roughtofinesolution[*,i] = res & $
   finewavesol[*,i] = res[0] + res[1]*roughwavesol[*,i] & $
   waveslit = finewavesol[*,i] & $
   save, res, waveslit, pts,pta, filename=slitwavefolder+'wavesol-slit'+strtrim(string(fix(i)),1)+'.sav' & $
   endif else begin & $
   restore,slitwavefolder+'wavesol-slit'+strtrim(string(fix(i)),1)+'.sav' & $
   finewavesol[*,i] = waveslit & $
   roughtofinesolution[*,i] = res & $
   endelse & $

   djs_oplot,finewavesol[*,i],slitarc[*,i]/max(slitarc[*,i]),color='orange' & $
   cursor,x,y,/up & $
   endelse & $
   endfor & $
   save, roughwavesol, finewavesol, filename='blue-wavesol.sav' & $
   endif else begin & $
   restore,'blue-wavesol.sav' & $
   endelse 


; now replot all the arcs on the same plot
wrange = [2000.,7500] ;angstroms

; ------*--------*------*--------*------*--------*------*--------*------*--------*
; Now plot all of the arc spectra in a line to see if they indeed,
; agree (based solely on the pixel shift inferred from slit positions)
window, 0, xsize=1024., ysize=nslits*25. 
xrange = [-2000,4096]  & $
djs_plot, [0,4096],[0,nslits+1.],/nodata,xran=wrange
for i=0, nslits - 1 do djs_plot,roughwavesol[*,i],slitarc[*,i]/max(slitarc[*,i])+i, color='red',xran=wrange,yran=[0,nslits+1.],/noerase
for i=0, nslits - 1 do djs_plot,finewavesol[*,i],slitarc[*,i]/max(slitarc[*,i])+i, color='blue',xran=wrange,yran=[0,nslits+1.],/noerase
; ------*--------*------*--------*------*--------*------*--------*------*--------*

window,1,xsize=1500,ysize=350
djs_plot,[0,4096.],[0,1],/nodata,xran=wrange
for i=0, nslits - 1 do djs_plot,finewavesol[*,i],slitarc[*,i]/max(slitarc[*,i]), color='light blue',xran=wrange,yran=[0,1.],/noerase,psym=3

