;flat fielding by the 3 flats for each red and blue
; required: file name of flats be in the format specified by findfile command

bflat = rotate(mrdfits('avflatlamp-blue.fits',0,bflathead),3)
rflat = rotate(mrdfits('avflatlamp-red.fits',0,rflathead),3)
bflatten = bflat
rflatten = rflat


rstep5file = (findfile('r-s5-*.sav'))[0]
bstep5file = (findfile('b-s5-*.sav'))[0]

;------
; BLUE 
;------
restore,bstep5file
goodslitsblue = (goodslits-1)/2.
flatspecb = fltarr(4096.,nslits)
;weightb = fltarr(4096.,nslits)

for i=0, nslits-1 do begin & $
   slitref = i*2 & $
   slitrange = findgen(floor(yslits[slitref+1])-ceil(yslits[slitref]))+ceil(yslits[slitref]) & $
;   print, slitrange & $
;   window, 0, xsize=1500.,ysize=500,xpos=0,ypos=1000 & $
;   astrim,alog10(bflat[*,(min(slitrange)-100.):(max(slitrange)+100.)]) & $
;   djs_oplot,xarr,ryt[*,min(slitrange)]-min(slitrange)+100.,color='green' & $
;   djs_oplot,xarr,ryt[*,max(slitrange)]-min(slitrange)+100.,color='blue' & $
   for k=0, 4096. - 1 do begin & $
   tmp = median(bflat[k,ryt[k,slitrange]]) & $
   tmp2 = stddev(bflat[k,ryt[k,slitrange]]) & $
   flatspecb[k,i] = tmp & $
;   weightb[k,i] = 1./(abs(tmp2)>0)^2. & $
   endfor & $
   smoothedspec = smooth(flatspecb[*,i],25,/nan) & $
   for k=0, 4096.-1 do begin & $
   bflatten[k,ryt[k,min(slitrange):max(slitrange)]] = bflat[k,ryt[k,min(slitrange):max(slitrange)]]/smoothedspec[k] & $
   endfor & $
   endfor


;-----
; RED
;-----
restore,rstep5file
goodslitsred = (goodslits-1)/2.
flatspecr = fltarr(4096.,nslits)
;weightr = fltarr(4096.,nslits)

for i=0, nslits-1 do begin & $
   slitref = i*2 & $
   slitrange = findgen(floor(yslits[slitref+1])-ceil(yslits[slitref]))+ceil(yslits[slitref]) & $
   for k=0, 4096. - 1 do begin & $
   tmp = median(rflat[k,ryt[k,slitrange]]) & $
   tmp2 = stddev(rflat[k,ryt[k,slitrange]]) & $
   flatspecr[k,i] = tmp & $
;   weightr[k,i] = 1./(abs(tmp2)>0)^2. & $
   endfor & $
   smoothedspec = smooth(flatspecr[*,i],25,/nan) & $
   for k=0, 4096. - 1 do begin & $
   rflatten[k,ryt[k,min(slitrange):max(slitrange)]] = rflat[k,ryt[k,min(slitrange):max(slitrange)]]/smoothedspec[k] & $
   endfor & $
   endfor

writefits,'avflat-pixtopix-red.fits',rotate(rflatten,1)
writefits,'avflat-pixtopix-blue.fits',rotate(bflatten,1)


; now apply the flat field to science images in the current directory
; (and flat fields to see the result - which should be = 1
;                                      throughout):

bluefiles = [findfile('simp.b*.fits'),findfile('simp.*arc-blue*.fits')];,blueflats]
redfiles = [findfile('simp.r*.fits'),findfile('simp.*arc-red*.fits')];,redflats]
outbluefiles = 'flat.'+bluefiles
outredfiles = 'flat.'+redfiles

nblue = n_elements(bluefiles)
nred = n_elements(redfiles)


flatblue = mrdfits('avflat-pixtopix-blue.fits',0,headblueflat)
for i=0, nblue - 1, 1 do begin & $
   img = mrdfits(bluefiles[i],0,head) & $
   img = img/flatblue & $
   writefits,outbluefiles[i],img,head & $
   endfor

flatred = mrdfits('avflat-pixtopix-red.fits',0,headredflat)
for i=0, nred - 1, 1 do begin & $
   img = mrdfits(redfiles[i],0,head) & $
   img = img/flatred & $
   writefits,outredfiles[i],img,head & $
   endfor

empropsred = replicate('...',nslits)
bad = takeaway(findgen(nslits),goodslitsred)
if bad ne -1 then empropsred[bad] = 'NODATA'
empropsblue = replicate('...',nslits)
bad = takeaway(findgen(nslits),goodslitsblue)
if bad ne -1 then empropsblue[bad] = 'NODATA'


forprint, findgen(nslits),fix(slittype[sortorder]),objname[sortorder],objpercent[sortorder],objpositionred,empropsred,objpositionblue,empropsblue,textout="slit-names-"+obj+".txt",format='(1i,1x,1i,1x,1a,1x,f10.3,1x,1i,1x,1a,1x,1i,1x,1a,1x)'

