redsci = findfile('flat.simp.r*.fits')
bluesci = findfile('flat.simp.b*.fits')

nred = n_elements(redsci)
nblue = n_elements(bluesci)

exptimered = fltarr(nred)
exptimeblue = fltarr(nblue)

xsize = 4096.
ysize = 4096.
superimred = fltarr(xsize,ysize,nred)
superimblue = fltarr(xsize,ysize,nblue)
superimrederr = fltarr(xsize,ysize,nred)
superimblueerr = fltarr(xsize,ysize,nblue)

for i=0, nred - 1, 1 do begin & $
   img = mrdfits(redsci[i],0,head) & $
   tmp = where(strmid(head,0,7) eq 'EXPTIME') & $
   print, head[tmp] & $
   exptimered[i] = double(strtrim(strmid(head[tmp],9,21),1)) & $
   superimred[*,*,i] = img/exptimered[i] & $
   superimrederr[*,*,i] = sqrt(img)/exptimered[i] & $
endfor
totaltimered = sum(exptimered)
redhead = head

for i=0, nblue - 1, 1 do begin & $
   img = mrdfits(bluesci[i],0,head) & $
   tmp = where(strmid(head,0,8) eq 'ELAPTIME') & $
   print, head[tmp] & $
   exptimeblue[i] = double(strtrim(strmid(head[tmp],9,21),1)) & $
   superimblue[*,*,i] = img/exptimeblue[i] & $
   superimblueerr[*,*,i] = sqrt(img)/exptimeblue[i] & $
endfor
totaltimeblue = sum(exptimeblue)
bluehead = head

;;; NOW COADD
redimg = median(superimred,dimension=3,/even)
superimredtmp = superimred*0.
for i=0, nred - 1 do superimredtmp[*,*,i] = superimred[*,*,i]*exptimered[i]
rederr = sqrt(total(superimredtmp,3))/totaltimered
writefits,'median-sci-red.fits',redimg,redhead
writefits,'median-sci-red.err.fits',rederr,redhead


blueimg = median(superimblue,dimension=3,/even)
superimbluetmp = superimblue*0.
for i=0, nblue - 1 do superimbluetmp[*,*,i] = superimblue[*,*,i]*exptimeblue[i]
blueerr = sqrt(total(superimbluetmp,3))/totaltimeblue
writefits,'median-sci-blue.fits',blueimg,bluehead
writefits,'median-sci-blue.err.fits',blueerr,bluehead


