visualize=1

setupfile = (findfile('mask_info/*.setup'))[0]
obj = strmid(setupfile,10,stregex(setupfile,'.setup')-10)
lread,setupfile,setup
;read_cat,(findfile('mask_info/*objlist.dat'))[0],objlist


setup = setup[63:*]
nsetup = n_elements(setup) - 1
setup = setup[0:(nsetup-1)]

xpos = fltarr(nsetup)
ypos = fltarr(nsetup)
ymin = fltarr(nsetup)
ymax = fltarr(nsetup)
percent = fltarr(nsetup)
objname = strarr(nsetup)
slittype = fltarr(nsetup)

xran = [0,250]
yran = [0,350]

for i=0, nsetup - 1 do begin & $
   tmp = strsplit(strtrim(strcompress(setup[i]),2),/extract) & $
   xpos[i] = double(tmp[0]) & $
   ypos[i] = double(tmp[1]) & $
   ymin[i] = double(tmp[2]) & $
   ymax[i] = double(tmp[3]) & $
   percent[i] = double(tmp[4]) & $
   objname[i] = tmp[8] & $
   if abs(tmp[4]-50.00) lt 0.005 then slittype[i] = -1. & $
   endfor

if visualize eq 1 then begin & $
window, 2, xsize=500, ysize=700 & $
djs_plot, xpos,ypos,xran=xran,yran=yran,psym=2,color='yellow' & $
oplot_lines,xpos,ymin,xpos,ymax,color='yellow' & $
for i=0, nsetup -1 do horz, ymin[i], color='red',line=2 & $
for i=0, nsetup -1 do horz, ymax[i], color='blue',line=1 & $
endif 

sortorder = sort(ymin)
yinall = [ymax[sortorder],ymin[sortorder]]
yinall = yinall[sort(yinall)]
realslit = where((findgen(n_elements(yinall)) mod 2) eq 1)
boxslits = where(slittype[sortorder] eq -1)

objpercent = percent[sortorder]*0.01

nslits = n_elements(xpos)

objinfo = strarr(nsetup)


tmp = strmid(obj,0,2)
if tmp eq 'cd' then begin & $
   cdfstag = 1 & $
   endif else begin & $
   cdfstag = 0 & $
   endelse

;for i=0, nsetup - 1 do begin & $
;   tmp = where(objlist.name eq objname[sortorder[i]],ct) & $
;   if ct gt 0 and cdfstag eq 0 then begin & $
;   objinfo[i] = string(double(objlist[tmp].ra))+' '+string(double(objlist[tmp].dec))+' '+string(double(objlist[tmp].rar))+' '+string(double(objlist[tmp].decr))+' '+string(double(objlist[tmp].imag))+' '+string(double(objlist[tmp].photz))+' '+string(double(objlist[tmp].f250))+' '+string(double(objlist[tmp].f350))+' '+string(double(objlist[tmp].f500)) & $
;   endif & $
;   if ct gt 0 and cdfstag eq 1 then begin & $
;   objinfo[i] = string(double(objlist[tmp].ra))+' '+string(double(objlist[tmp].dec))+' '+string(double(objlist[tmp].mag))+' '+string(double(objlist[tmp].f250))+' '+string(double(objlist[tmp].f350))+' '+string(double(objlist[tmp].f500)) & $
;   endif & $
;   endfor




forprint, fix(findgen(nslits)),fix(slittype[sortorder]),objname[sortorder],textout="slit-info-"+obj+".txt",format='(1i,1x,1i,1x,1a,1x,1a)'
;forprint, fix(findgen(nslits)),fix(slittype[sortorder]),objname[sortorder],objinfo,textout="slit-info-"+obj+".txt",format='(1i,1x,1i,1x,1a,1x,1a)'
;forprint, findgen(nslits), xpos[sortorder],objname[sortorder],objpercent[sortorder],textout="slit-names-"+obj+".txt"
save,xpos,ypos,ymin,ymax,percent,objname,sortorder,filename='slits-fromsetup.sav'

