visualize=0
;visualize=1

restore,'red-wavesol.sav'
;@plot-setup
step3file = (findfile('r-s3-*.sav'))[0]
restore,step3file
obj = strmid(step3file,5,stregex(step3file,'.sav')-5)
step4file=(findfile('r-s4-*.sav'))[0]
restore,step4file
step5file=(findfile('r-s5-*.sav'))[0]
restore,step5file

scifile = (findfile('median-sci-red.fits'))[0]
scierrfile = (findfile('median-sci-red.err.fits'))[0]
sciimg = mrdfits(scifile,0,headsci)
scierr = mrdfits(scierrfile,0,headscierr)

rsciimg = rotate(sciimg,3)
rscierr = rotate(scierr,3)


skipslits = [boxslits,fix(badslits/2.)]


;OBJECT POSITION ON THE SLIT:
slitcount = findgen(nslits)
if badslits ne -1 then begin & $
   set2 = fix(setintersection(realslit,[badslits])/2.) & $
   if n_elements(set2) gt 1 and set2 ne -1 then slitcount = takeaway(slitcount,set2) & $
endif
objpos = objpercent*slitwidth
slitstart = ry[0,goodslits-1] + objpos[slitcount]


;------------------
;plot initial setup with arc image:
;------------------

if visualize eq 1 then begin & $
window,0,xsize=1000,ysize=1000 & $
astrim,alog10(rsciimg<5>(0.001)) & $
djs_oplot,rx[*,gdslits],ry[*,gdslits],psym=3,color='red' & $
djs_oplot,rx[*,gdslits],ryt[*,slitstart[gdslits]],psym=3,color='yellow' & $
xyouts,rx[1000,gdslits],ry[1000,gdslits],slitnumber[gdslits],color=djs_icolor('red') & $
   endif


;----------------------------%
; RECTIFY
;----------------------------%

; RECTIFY WRT Both X and Y Pixels...

; derivative of the trace function...
dryt = ryt * 0.
for ystart = 0, 4096. - 1 do dryt[*,ystart] = (shift(ryt[*,ystart],1) - shift(ryt[*,ystart],-1.)) ;/2.
; this is the slope of the trace as a function of [xpix, ystart] -
; units are (dypix/dxpix)
dryt[0,*] = dryt[1,*] ;replace the first pixel
dryt[4095,*] = dryt[4094,*] ;replace the first pixel
;what is the opening angle, in other words angle of vertical against
;the trace?
angle = ryt * 0.
angle = atan(1./dryt) ;in radians
tmp = where(angle lt 0)
angle[tmp] = angle[tmp] + !pi



newimgrect = rsciimg*0.
newimgrecterr = rsciimg*0.
newimgrectsky = rsciimg*0.
newimgrectskyerr = rsciimg*0.
scirectsky = newimgrectsky*0.
scirectskyerr = newimgrectsky*0.

for slit=0, nslit-1, 1 do begin & $
   tmp = where(goodslits eq slit, ngd) & $
   tmp2 = where(badslits eq slit-1, nbad) & $
   if ngd gt 0 and nbad lt 1 then begin & $
   slitno = fix((slit-1)/2.) & $
   allslitbounds = [fix(yslits[slit-1]),fix(yslits[slit])] & $
   allslitpos = findgen((allslitbounds[1]-allslitbounds[0]))+allslitbounds[0] & $
   shiftx = fltarr(4096,n_elements(allslitpos)) & $
   for slitpos=0, n_elements(allslitpos) -1 do begin & $
   shiftx[*,slitpos] = xarr + (allslitpos[slitpos] - allslitpos[0])*tan(!pi/2. - angle[xarr,allslitpos[slitpos]]) & $   
   data = xarr*0. & $
   dataerr = xarr*0. & $
   for xpt=0, 4096-1 do begin & $
   data[xpt] = rsciimg[xpt,ryt[xpt,allslitpos[slitpos]]] & $
   dataerr[xpt] = rscierr[xpt,ryt[xpt,allslitpos[slitpos]]] & $
   endfor & $
   datashift = interpol(data,shiftx[*,slitpos],xarr) & $
   dataerrshift = interpol(dataerr,shiftx[*,slitpos],xarr) & $
   scirectsky[*,allslitpos[slitpos]] = datashift & $
   scirectskyerr[*,allslitpos[slitpos]] = dataerrshift & $
   endfor & $
   for xpt=0, 4096-1 do begin & $
   newimgrectsky[xpt,xarr[allslitpos]] = rsciimg[xpt,ryt[xpt,allslitpos]] & $
   newimgrectskyerr[xpt,xarr[allslitpos]] = rscierr[xpt,ryt[xpt,allslitpos]] & $
   endfor & $
   endif & $
   endfor 
;writefits,obj+'noskysub-sci-red.fits',newimgrectsky
;writefits,obj+'noskysub-sci-red.err.fits',newimgrectskyerr
writefits,obj+'noskysub-sci-red.fits',scirectsky
writefits,obj+'noskysub-sci-red.err.fits',scirectskyerr


;measure exact xshift value in angstroms:
minwave = floor(min(finewavesol[where(finewavesol gt 0)]))
maxwave = ceil(max(finewavesol))
binwave = 0.8 ;average dispersion
waveshift = fltarr(nslits)
wavearr = findgen((maxwave-minwave)/binwave + 1)*binwave + minwave

maxshift = ceil((max(finewavesol[0,*])-minwave)/binwave)
shiftimg = fltarr(n_elements(wavearr),4096)
shiftimgerr = fltarr(n_elements(wavearr),4096)


for slit=0, nslit-1 do begin & $
   tmp = where(goodslits eq slit, ngd) & $
   tmp2 = where(badslits eq slit-1, nbad) & $
   if ngd gt 0 and nbad lt 1 then begin & $
   slitno = fix((slit-1)/2.) & $
   minwavei = min(finewavesol[*,slitno]) & $
   waveshift[slitno] = minwavei-minwave & $
   shiftpx = (waveshift[slitno]/binwave)>0 & $
   allslitbounds = [fix(yslits[slit-1]),fix(yslits[slit])] & $
   allslitpos = findgen((allslitbounds[1]-allslitbounds[0]))+allslitbounds[0] & $
   for j=0, n_elements(allslitpos) - 1 do begin & $
   tmpimg = scirectsky[*,xarr[allslitpos[j]]] & $
   tmpimg2 = scirectsky[*,xarr[allslitpos[j]]] & $
   res = interpol(tmpimg,finewavesol[*,slitno],wavearr) & $
   res2 = interpol(tmpimg2,finewavesol[*,slitno],wavearr) & $
   outofbounds = where(wavearr le min(finewavesol[*,slitno]) or wavearr gt max(finewavesol[*,slitno])) & $
   res[outofbounds] = 0. & $
   res2[outofbounds] = 999. & $
   shiftimg[*,xarr[allslitpos[j]]] = res & $
   shiftimgerr[*,xarr[allslitpos[j]]] = res2 & $
   endfor & $
;   shiftimg[(shiftpx):(shiftpx+4095),xarr[allslitpos]] = scirectsky[*,xarr[allslitpos]] & $
;   print,'finished slit', slitno, slit,shiftpx & $
   endif & $
   endfor

skyflux = wavearr*0.
skyfluxerr = wavearr*0.

for i=0, n_elements(wavearr)-1 do begin & $
   tmp = where(shiftimgerr[i,*] ne 999.,ct) & $
   med = median(shiftimg[i,tmp]) & $
   skyflux[i] = med & $
   skyfluxerr[i] = stddev(shiftimg[i,tmp]) & $
   endfor

astrim,alog10(shiftimg)
djs_oplot, skyflux/max(skyflux) * 1000., color='blue'


;-------------------------%
; REMOVE SKY LINES
;-------------------------%

extwidth = 5.

slitobj = fltarr(4096.,nslits)
slitobjerr = fltarr(4096.,nslits)
slitsky = fltarr(4096.,nslits)
slitskyerr = fltarr(4096.,nslits)
edgedist = 2.

for slit=0, nslit-1, 1 do begin & $
   tmp = where(goodslits eq slit, ngd) & $
   tmp2 = where(badslits eq slit-1, nbad) & $
   if ngd gt 0 and nbad lt 1 then begin & $
   slitno = fix((slit-1)/2.) & $
   slitwidth[slitno] = yslits[slit] - yslits[slit-1] & $
   loadct,5 & $
   yrange = minmax(ry[*,(slit-1):(slit)])+[-10,10] & $
;;; now compute obj and sky spectra & $
   allslitbounds = [fix(yslits[slit-1]),fix(yslits[slit])] & $
   allslitpos = findgen((allslitbounds[1]-allslitbounds[0]))+allslitbounds[0] & $
   if slitwidth[slitno] gt extwidth*2.+edgedist*2.+3. then objposbounds = [fix(yslits[slit-1]+objpos[slitno]-extwidth),fix(yslits[slit-1]+objpos[slitno]+extwidth)] & $
   if slitwidth[slitno] le extwidth*2.+edgedist*2.+3. then objposbounds = [fix(yslits[slit-1]+objpos[slitno]-extwidth/2.),fix(yslits[slit-1]+objpos[slitno]+extwidth/2.)] & $
   objposex = findgen((objposbounds[1]-objposbounds[0]))+objposbounds[0] & $
   skyposbounds = [fix(yslits[slit-1]+edgedist),fix(yslits[slit]-edgedist)] & $
   skyposex = takeaway(findgen((skyposbounds[1]-skyposbounds[0]))+skyposbounds[0],objposex) & $
   for xpt=0, 4096-1 do begin & $
   objtmp = median(reform(scirectsky[xpt,xarr[objposex]])) & $
   objtmp2 = median(reform(scirectskyerr[xpt,xarr[objposex]])) & $
   slitobj[xpt,slitno] = objtmp & $
   slitobjerr[xpt,slitno] = objtmp2 & $
   skytmp = median(reform(scirectsky[xpt,xarr[skyposex]])) & $
   skytmp2 = median(reform(scirectskyerr[xpt,xarr[skyposex]])) & $
   slitsky[xpt,slitno] = skytmp & $
   slitskyerr[xpt,slitno] = skytmp2 & $
   newimgrect[xpt,xarr[allslitpos]] = scirectsky[xpt,xarr[allslitpos]] - slitsky[xpt,slitno] & $
   newimgrecterr[xpt,xarr[allslitpos]] = sqrt(scirectskyerr[xpt,xarr[allslitpos]]^2. + slitskyerr[xpt,slitno]^2.) & $
   endfor & $
   if visualize eq 2 then begin & $
;;; now plot result & $
   window,1,xsize=1024.,ysize=400. & $
;   tvimage,fltscl(rsciimg[*,(yrange[0]):(yrange[1])],/tv),pos=[0,0,1,0.3] & $
;   djs_plot, xarr,ryt[*,fix(yslits[slit-1]+objpos[fix((slit-1)/2.)]+extwidth)]-yrange[0], color='red', $ & $
;   /noerase,pos=[0,0,1,0.3],yran=yrange-yrange[0] & $
;   djs_oplot, xarr,ryt[*,fix(yslits[slit-1]+objpos[fix((slit-1)/2.)]-extwidth)]-yrange[0], color='red' & $
;   djs_oplot, xarr,ryt[*,fix(yslits[slit])]-yrange[0], color='dark green',thick=3 & $
;   djs_oplot, xarr,ryt[*,fix(yslits[slit-1])]-yrange[0], color='green',thick=3 & $
   tvimage,fltscl(newimgrect[*,(yslits[slit]-1):(yslits[slit])],/tv),pos=[0,0,1,0.3] & $
   horz,objposbounds,color='red' & $
   horz, allslitbounds, color='green',thick=3 & $
   legend,['SLIT'+string(slitno)] & $
   djs_plot,xarr,slitobj[*,slitno]-slitsky[*,slitno],pos=[0,0.35,1.0,0.95],/noerase & $
   wait,0.1 & $
   wdelete,1 & $
   endif & $
   endif & $
endfor
writefits,obj+'reduced-sci-red.fits',newimgrect
writefits,obj+'reduced-sci-red.err.fits',newimgrecterr












;measure exact xshift value in angstroms:
minwave = min(finewavesol[where(finewavesol gt 0)])
maxwave = max(finewavesol)
binwave = 0.8 ;average dispersion
waveshift = fltarr(nslits)
wavearr = findgen((maxwave-minwave)/binwave + 1)*binwave + minwave
shiftimg = fltarr(n_elements(wavearr),4096)

for slit=0, nslit-1 do begin & $
   tmp = where(goodslits eq slit, ngd) & $
   tmp2 = where(badslits eq slit-1, nbad) & $
   if ngd gt 0 and nbad lt 1 then begin & $
   slitno = fix((slit-1)/2.) & $
   minwavei = min(finewavesol[*,slitno]) & $
   waveshift[slitno] = minwavei-minwave & $
   shiftpx = floor(waveshift[slitno]/binwave)>0 & $
   allslitbounds = [fix(yslits[slit-1]),fix(yslits[slit])] & $
   allslitpos = findgen((allslitbounds[1]-allslitbounds[0]))+allslitbounds[0] & $
   for j=0, n_elements(allslitpos) - 1 do begin & $
   tmpimg = newimgrect[*,xarr[allslitpos[j]]] & $
   res = interpol(tmpimg,finewavesol[*,slitno],wavearr) & $
   outofbounds = where(wavearr le min(finewavesol[*,slitno]) or wavearr gt max(finewavesol[*,slitno])) & $
   res[outofbounds] = 0. & $
   shiftimg[*,xarr[allslitpos[j]]] = res & $
   endfor & $
;   shiftimg[(shiftpx):(shiftpx+4095),xarr[allslitpos]] = newimgrect[*,xarr[allslitpos]] & $
   endif & $
   endfor

q = "'"
head2 = ['SIMPLE  =                    T / Written by IDL', $
         'BITPIX  =                  -32 / Number of bits per data pixel', $
         'NAXIS   =                    2 / Number of data axes', $
         'NAXIS1  =           '+string(n_elements(shiftimg[*,0])), $
         'NAXIS2  =                 4096 ', $
         'EXTEND  =                    T / FITS data may contain extensions', $
         'CTYPE1  = '+q+'WAVELENGTH'+q, $
         'CUNIT1  = '+q+'Angstrom'+q, $
         'CTYPE2  = '+q+'SPECTRUM'+q, $
         'CUNIT2  = '+q+'Number  '+q, $
         'CRPIX1  =                   1.', $
         'CRVAL1  =       '+string(minwave), $
         'CD1_1   =       '+string(binwave), $
         'CRPIX2  =       '+string(binwave), $
         'CRVAL2  =                   0.', $
         'CD2_2   =                   0.', $
         'END']

writefits,obj+'reduced-wavelength-sci-red.fits',shiftimg,head2

smoothed = filter_image(shiftimg,fwhm=[4,3],/all)  ; smooth more in x direction than in y
writefits,obj+'reduced-wavelength-sci-red-4G.fits',smoothed,head2









;skywave = -1.
;skyflux = -1.
;;skyfluxerr = -1.;
;
;for i=0, nslits-1 do begin & $
;   skywave = [skywave,finewavesol[*,i]] & $
;   skyflux = [skyflux,slitsky[*,i]] & $
;   skyfluxerr = [skyfluxerr,slitskyerr[*,i]] & $
;   endfor
;skywave = skywave[1:*]
;skyflux = skyflux[1:*]
;skyfluxerr = skyfluxerr[1:*]
;min = 4000.
;max = 9000.
;bin = 2.
;wavearr = findgen((max-min)/bin+1)*bin + min
;
;fluxarr= binup(skyflux,skywave,wavearr,inerr=skyfluxerr,outerr=fluxerr)
